<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="../bower_components/vaadin-grid/vaadin-grid-sorter.html">
<link rel="import" href="../bower_components/paper-spinner/paper-spinner-lite.html">
<link rel="import" href="../bower_components/paper-dropdown-menu/paper-dropdown-menu.html">
<link rel="import" href="../bower_components/paper-item/paper-item.html">
<link rel="import" href="../bower_components/paper-listbox/paper-listbox.html">

<!--<script src="../bower_components/moment/min/moment.min.js"></script>-->
<link rel="import" href="shared-styles.html">

<dom-module id="transaction-list">
  <template>
    <style include="shared-styles">
      :host {
        display: block;

        padding: 10px;
      }
     :host(:focus), .paper-item:focus{ background: #FFCCBC}
     .totalAmount{ text-align: right}
       paper-button.indigo {
    background-color: var(--paper-indigo-500);
    color: white;
    --paper-button-raised-keyboard-focus: {
      background-color: var(--paper-pink-a200) !important;
      color: white !important;
    };
  }
  paper-button.indigo:hover {
    background-color: var(--paper-indigo-400);
  }
   .card h1{    margin: 0px;
    padding: 0px 0px 11px 0px;
    
    border-bottom: 1px solid #FF6D00;}
    
    </style>

      <iron-ajax id="submitme"
      handle-as"json"
      debounce-duration="300"
      on-response="_handleResponse"></iron-ajax>

    <div class="card">
      <p style="text-align:right">Welcome <strong>[[data.userName]]</strong> <paper-button class="pink" style="color:#dd2c00;" on-tap="_logout">Logout</paper-button> </p>
      <h1>Transaction History</h1>
    <div style="margin-top:12px;">
      <vaadin-grid id="grid" page-size="2" aria-label="Transaction list" items="[[transactionData]]">

         <!--<vaadin-grid-column>
          <template class="header">
            <vaadin-grid-sorter path="transactionId" direction="asc">Transaction Id</vaadin-grid-sorter>
          </template>
          <template>[[item.transactionId]]</template>
        </vaadin-grid-column>-->

        <vaadin-grid-column>
          <template class="header">
            <vaadin-grid-sorter path="transactionType" direction="asc">Transction Type</vaadin-grid-sorter>
          </template>
          <template>[[item.transactionType]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">
            <vaadin-grid-sorter path="transactionAmount">Transction Amount</vaadin-grid-sorter>
          </template>
          <template>[[item.transactionAmount]]</template>
        </vaadin-grid-column>

         <vaadin-grid-column>
          <template class="header">
            <vaadin-grid-sorter path="time">Transaction Date</vaadin-grid-sorter>
          </template>
          <template>[[item.time]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column>
          <template class="header">
            <vaadin-grid-sorter path="balance">Available Balance</vaadin-grid-sorter>
          </template>
          <template>[[item.balance]]</template>
        </vaadin-grid-column>

        <vaadin-grid-column width="150px">
          <template class="header">
            <vaadin-grid-sorter path="description">Description</vaadin-grid-sorter>
          </template>
          <template>[[item.description]]</template>
        </vaadin-grid-column> 
        
      </vaadin-grid>
      <!--<div id="pages">
      <button on-click="_prev">&lt;</button>
      <template is="dom-repeat" items="[[pages]]">
        <button on-click="_select" selected$="[[_isSelected(page, item)]]">[[item]]</button>
      </template>
      <button on-click="_next">&gt;</button>
    </div>-->
      </div>
       
     <div style="margin-top:10px; text-align:right;">           
        <paper-button raised class="indigo" on-tap="_fundTransfer">Fund Transfer</paper-button>        
      </div>
    </div>
  </template>

  <script>
    class TransactionList extends Polymer.Element {
      static get is() { return 'transaction-list'; }
       
     static get properties(){
        return{
          // transactionId:{
          //   type:Number,
          //   value:""
          // },
          transactionType:{
            type:String,
            value:""
          },
          transactionAmount:{
            type:String,
            value:''
          },
          time:{
            type:Date,
            value:''
          },
          balance:{
            type:String,
            value:''
          },
          description:{
            type:String,
            value:''
          },
           items: Array,
            page: Number,
            pages: Array
        }
      }
      static get observers() {
          return ['_itemsChanged(items, page)'];
        }
      constructor(){
        super();
         this.data=JSON.parse(localStorage.getItem('transactionData'));
         this.transactionData=this.data.trData;
         this.page = 0;
         console.log(this.transactionData);
      }
      _fundTransfer(){
        window.location.href="/fundTransfer"
      }
      _logout(){
        window.location.href="/login";
        localStorage.removeItem(transactionData);
      }
      _isSelected(page, item) {
          return page === item - 1;
        }

        _select(e) {
          this.page = e.model.item - 1;
        }

        _next() {
          this.page = Math.min(this.pages.length - 1, this.page + 1);
        }

        _prev() {
          this.page = Math.max(0, this.page - 1);
        }

        _itemsChanged(items, page) {
          if (items === undefined || page === undefined) {
            return;
          }

          if (!this.pages) {
            this.pages = Array
              .apply(null, {length: Math.ceil(items.length / this.$.grid.pageSize)}).map((item, index) => index + 1);
          }

          const start = page * this.$.grid.pageSize;
          const end = (page + 1) * this.$.grid.pageSize;
          this.$.grid.items = items.slice(start, end);
        }
     
     
    }

    window.customElements.define(TransactionList.is, TransactionList);
  </script>
</dom-module>
